<script lang="ts">
  import { createEventDispatcher, onMount } from 'svelte';
  import { Button, Dropdown, DropdownItem, DropdownMenu, DropdownToggle } from '@sveltestrap/sveltestrap';
  import { GetAllEnabledBlueTeams } from '@queries/Team';
  import type { Team } from '@models/Team';
  import { eventId } from '@stores';
  import Fa from 'svelte-fa';
  import { faCaretDown } from '@fortawesome/free-solid-svg-icons';

  const dispatch = createEventDispatcher();
  // Whether to select disabled teams from database
  export let blueteams: Array<Team> = [];
  export let selectedTeam: Team | null = null;
  let isOpen = false;

  onMount(async () => {
    await initBlueTeams();
  });

  async function initBlueTeams() {
    blueteams = await GetAllEnabledBlueTeams($eventId);
  }
</script>

<Dropdown bind:isOpen class="mb-2 d-inline-block">
  <!--  <DropdownToggle caret>{selectedTeam ? selectedTeam.name : 'Select team'}</DropdownToggle>-->
  <DropdownMenu>
    {#each blueteams as bt}
      <DropdownItem
        class="clickable"
        on:click={() => {
          selectedTeam = bt;
          dispatch('click');
        }}
      >
        {bt.name}
      </DropdownItem>
    {/each}
  </DropdownMenu>
</Dropdown>

<!-- After the dropdown so the dropdown appears on top of the button instead of next to it -->
<Button
  on:click={(e) => {
    e.preventDefault(); // prevent submission of form on click
    isOpen = !isOpen;
  }}
  class="rounded-start-1 rounded-end-0"
  color="secondary"
>
  {selectedTeam ? selectedTeam.name : 'Select team'}
  <Fa icon={faCaretDown} />
</Button>
